import { AssetManager } from "cc";
import { BundleConfigs } from "./BundleConfigs";
import { ILoadResInfo } from "../../../scripts/load/interfaces/ILoadResInfo";

export default class LoadResConst {

    //////////////////////////////////////////////////////////////////////mainbundle

    /////////////////////////////////////////////zip
    public static ConfigTable: ILoadResInfo = { bundle: BundleConfigs.CommonBundle, path: "/res/configtable/configtable" };


    //////////////////////////////////////////////////////////////////////gamebundle

    /////////////////////////////////////////////prefab
    public static FightArrow: ILoadResInfo = { bundle: BundleConfigs.FightBundle, path: "/prefabs/fight/FightArrow" };
    public static EnemyPrefab_1: ILoadResInfo = { bundle: BundleConfigs.FightBundle, path: "/prefabs/entitys/EnemyPrefab_1" };
    public static SoldierPrefab_1: ILoadResInfo = { bundle: BundleConfigs.FightBundle, path: "/prefabs/entitys/SoldierPrefab_1" };
    public static TowerPrefab_Soldier_1: ILoadResInfo = { bundle: BundleConfigs.FightBundle, path: "/prefabs/entitys/TowerPrefab_Soldier_1" };
    public static TowerPrefab_Defense_1: ILoadResInfo = { bundle: BundleConfigs.FightBundle, path: "/prefabs/entitys/TowerPrefab_Defense_1" };
    public static TowerPrefab_Hero_1: ILoadResInfo = { bundle: BundleConfigs.FightBundle, path: "/prefabs/entitys/TowerPrefab_Hero_1" };
    public static TowerPrefab_Normal_1: ILoadResInfo = { bundle: BundleConfigs.FightBundle, path: "/prefabs/entitys/TowerPrefab_Normal_1" };







    //////////////////////////////////////////////////////////////////////gameTFbundle
    
    /////////////////////////////////////////////prefab
    public static SoldierPrefab_TF: ILoadResInfo = { bundle: BundleConfigs.FightTFBundle, path: "/prefabs/entitys/soldiers" };
    public static TowerDef_TF: ILoadResInfo = { bundle: BundleConfigs.FightTFBundle, path: "/prefabs/entitys/towerDef" };
    public static WarCar_self_TF: ILoadResInfo = { bundle: BundleConfigs.FightTFBundle, path: "/prefabs/entitys/warCar_self" };
    public static WarCar_enemy_TF: ILoadResInfo = { bundle: BundleConfigs.FightTFBundle, path: "/prefabs/entitys/warCar_enemy" };
}