System.register(["__unresolved_0", "cc", "__unresolved_1"], function (_export, _context) {
  "use strict";

  var _reporterNs, _cclegacy, ScrollViewPlusItemComponent, _decorator, ScrollView, UITransform, v3, rect, _dec, _class, _class2, _descriptor, _crd, ccclass, property, ScrollViewPlusComponent;

  function _initializerDefineProperty(target, property, descriptor, context) { if (!descriptor) return; Object.defineProperty(target, property, { enumerable: descriptor.enumerable, configurable: descriptor.configurable, writable: descriptor.writable, value: descriptor.initializer ? descriptor.initializer.call(context) : void 0 }); }

  function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) { var desc = {}; Object.keys(descriptor).forEach(function (key) { desc[key] = descriptor[key]; }); desc.enumerable = !!desc.enumerable; desc.configurable = !!desc.configurable; if ('value' in desc || desc.initializer) { desc.writable = true; } desc = decorators.slice().reverse().reduce(function (desc, decorator) { return decorator(target, property, desc) || desc; }, desc); if (context && desc.initializer !== void 0) { desc.value = desc.initializer ? desc.initializer.call(context) : void 0; desc.initializer = undefined; } if (desc.initializer === void 0) { Object.defineProperty(target, property, desc); desc = null; } return desc; }

  function _initializerWarningHelper(descriptor, context) { throw new Error('Decorating class property failed. Please ensure that ' + 'proposal-class-properties is enabled and runs after the decorators transform.'); }

  function _reportPossibleCrUseOfScrollViewPlusItemComponent(extras) {
    _reporterNs.report("ScrollViewPlusItemComponent", "./ScrollViewPlusItemComponent", _context.meta, extras);
  }

  return {
    setters: [function (_unresolved_) {
      _reporterNs = _unresolved_;
    }, function (_cc) {
      _cclegacy = _cc.cclegacy;
      _decorator = _cc._decorator;
      ScrollView = _cc.ScrollView;
      UITransform = _cc.UITransform;
      v3 = _cc.v3;
      rect = _cc.rect;
    }, function (_unresolved_2) {
      ScrollViewPlusItemComponent = _unresolved_2.default;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "f513e+E0UdCtIsfJE6NqBlk", "ScrollViewPlusComponent", undefined);

      ({
        ccclass,
        property
      } = _decorator);
      /**
       * 只渲染可视区域的ScrollView
       *
       * @author caizhitao
       * @created 2020-12-27 22:08:00
       * @description
       *
       * 用法：
       *
       *      1. 将本组件挂载在节点上即可，和正常ScrollView使用一致
       *
       * 原理：
       *
       *      1. 滚动时，判断子节点是否进入了/离开了可视区域
       *      2. 根据结果回调对应事件，在可以实现类似以下功能：
       *          * 控制可视区域Item显示（透明度改为 255 ），非可视区域Item隐藏（透明度改为 0 ）
       */

      _export("default", ScrollViewPlusComponent = (_dec = property({
        tooltip: "是否计算在可视区域中Item的相对位置（可能会相对耗性能）"
      }), ccclass(_class = (_class2 = class ScrollViewPlusComponent extends ScrollView {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "caculatePosition", _descriptor, this);
        }

        onEnable() {
          super.onEnable();
          this.node.on("scrolling", this._onScrollingDrawCallOpt, this);
        }

        onDisable() {
          super.onDisable();
          this.node.off("scrolling", this._onScrollingDrawCallOpt, this);
        }

        _onScrollingDrawCallOpt() {
          this.content.children.length > 0 && this.optDc();
        }

        optDc() {
          ScrollViewPlusComponent.optDc(this, this.caculatePosition);
        }
        /**
         * 判断目标节点是否在 ScrollView 的可视区域中
         *
         * @param targetNode 目标节点
         */


        isNodeVisiable(node) {
          return ScrollViewPlusComponent.isNodeVisiable(this, node);
        }
        /**
         * 判断目标节点是否在 ScrollView 的可视区域中
         *
         * @param scrollView ScrollView 组件
         * @param targetNode 目标节点
         */


        static isNodeVisiable(scrollView, targetNode) {
          // 获取 ScrollView Node 的左下角坐标在世界坐标系中的坐标
          let svLeftBottomPoint = scrollView.node.parent.getComponent(UITransform).convertToWorldSpaceAR(v3(scrollView.node.position.x - scrollView.node.getComponent(UITransform).anchorX * scrollView.node.getComponent(UITransform).width, scrollView.node.position.y - scrollView.node.getComponent(UITransform).anchorY * scrollView.node.getComponent(UITransform).height)); // 求出 ScrollView 可视区域在世界坐标系中的矩形（碰撞盒）

          let svBBoxRect = rect(svLeftBottomPoint.x, svLeftBottomPoint.y, scrollView.node.getComponent(UITransform).width, scrollView.node.getComponent(UITransform).height);
          return targetNode.getComponent(UITransform).getBoundingBoxToWorld().intersects(svBBoxRect);
        }
        /**
         * 优化 ScrollView Content 节点 DC，可以手动调用
         *
         * 具体为
         *
         * 1. 进入ScrollView可视区域是，回调对应 Content 子节点上挂载的 ScollViewPlusItem 组件的 onEnterScorllViewEvents 数组事件
         * 2. 退出ScrollView可视区域是，回调对应 Content 子节点上挂载的 ScollViewPlusItem 组件的 onExitScorllViewEvents 数组事件
         */


        static optDc(scrollView, caculatePosition = false) {
          // 获取 ScrollView Node 的左下角坐标在世界坐标系中的坐标
          let svLeftBottomPoint = scrollView.node.parent.getComponent(UITransform).convertToWorldSpaceAR(v3(scrollView.node.position.x - scrollView.node.getComponent(UITransform).anchorX * scrollView.node.getComponent(UITransform).width, scrollView.node.position.y - scrollView.node.getComponent(UITransform).anchorY * scrollView.node.getComponent(UITransform).height)); // 求出 ScrollView 可视区域在世界坐标系中的矩形（碰撞盒）

          let svBBoxRect = rect(svLeftBottomPoint.x, svLeftBottomPoint.y, scrollView.node.getComponent(UITransform).width, scrollView.node.getComponent(UITransform).height); // 遍历 ScrollView Content 内容节点的子节点，对每个子节点的包围盒做和 ScrollView 可视区域包围盒做碰撞判断

          scrollView.content.children.forEach(childNode => {
            // 没有绑定指定组件的子节点不处理
            let itemComponent = childNode.getComponent(_crd && ScrollViewPlusItemComponent === void 0 ? (_reportPossibleCrUseOfScrollViewPlusItemComponent({
              error: Error()
            }), ScrollViewPlusItemComponent) : ScrollViewPlusItemComponent);

            if (itemComponent == null) {
              return;
            } // 如果相交了，那么就显示，否则就隐藏


            let childNodeBBox = childNode.getComponent(UITransform).getBoundingBoxToWorld();

            if (childNodeBBox.intersects(svBBoxRect)) {
              if (!itemComponent.isShowing) {
                itemComponent.isShowing = true;
                itemComponent.publishOnEnterScrollView();
              }

              if (caculatePosition) {
                if (itemComponent.isShowing) {
                  itemComponent.publishOnPositionChange((childNodeBBox.x - (svBBoxRect.x - childNodeBBox.width / 2)) / (childNodeBBox.width + svBBoxRect.width), (childNodeBBox.y - (svBBoxRect.y - childNodeBBox.height / 2)) / (childNodeBBox.height + svBBoxRect.height));
                }
              }
            } else {
              if (itemComponent.isShowing) {
                itemComponent.isShowing = false;
                itemComponent.publishOnExitScrollView();
              }
            }
          });
        }

      }, (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "caculatePosition", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return false;
        }
      })), _class2)) || _class));

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=4853276fadb0f0b3a1939336d9b9a6d876273df2.js.map