System.register(["cc"], function (_export, _context) {
  "use strict";

  var _cclegacy, _decorator, Component, _dec, _class, _crd, ccclass, property, EnhancedComponent;

  return {
    setters: [function (_cc) {
      _cclegacy = _cc.cclegacy;
      _decorator = _cc._decorator;
      Component = _cc.Component;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "add014ilbFEpIEmxppS3COj", "EnhancedComponent", undefined);

      ({
        ccclass,
        property
      } = _decorator);
      /**
       * 增强型组件（额外附加一些方法）
       * 
       * @author caizhitao
       * @created 2020-12-02 21:25:28
       */

      _export("EnhancedComponent", EnhancedComponent = (_dec = ccclass('EnhancedComponent'), _dec(_class = class EnhancedComponent extends Component {
        /**
         * 分帧执行 Generator 逻辑
         *
         * @param generator 生成器
         * @param duration 持续时间（ms），每次执行 Generator 的操作时，最长可持续执行时长，如：8ms，即正常1帧（16ms）下，分一半时间给此逻辑执行
         */
        executePreFrame(generator, duration) {
          return new Promise((resolve, reject) => {
            let gen = generator;

            let runGenerator = () => {
              let startTime = new Date().getTime();

              for (let iter = gen.next();; iter = gen.next()) {
                if (iter == null || iter.done) {
                  resolve();
                  return;
                }

                if (new Date().getTime() - startTime > duration) {
                  this.scheduleOnce(() => {
                    runGenerator();
                  });
                  return;
                }
              }
            };

            runGenerator();
          });
        }

      }) || _class));

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=5bb0dfdc0839a7c67020f7b6816410e06e6fb488.js.map