System.register(["__unresolved_0", "cc", "__unresolved_1"], function (_export, _context) {
  "use strict";

  var _reporterNs, _cclegacy, BundleConfigs, _crd, PanelLayerEnum, PanelConfigs;

  function _reportPossibleCrUseOfPanelConfig(extras) {
    _reporterNs.report("PanelConfig", "../../../scripts/framework/lib/router/PanelConfig", _context.meta, extras);
  }

  function _reportPossibleCrUseOfBundleConfigs(extras) {
    _reporterNs.report("BundleConfigs", "./BundleConfigs", _context.meta, extras);
  }

  return {
    setters: [function (_unresolved_) {
      _reporterNs = _unresolved_;
    }, function (_cc) {
      _cclegacy = _cc.cclegacy;
    }, function (_unresolved_2) {
      BundleConfigs = _unresolved_2.BundleConfigs;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "e7ecd/pixpPoKthkR19avi2", "PanelConfigs", undefined);

      (function (PanelLayerEnum) {
        PanelLayerEnum[PanelLayerEnum["UILayer"] = 200] = "UILayer";
        PanelLayerEnum[PanelLayerEnum["PopLayer"] = 400] = "PopLayer";
      })(PanelLayerEnum || (PanelLayerEnum = {}));

      /**
       * 游戏面板配置
       */
      _export("PanelConfigs", PanelConfigs = {
        // ///////////////////////////////////////////////////////
        // 普通页面层级

        /**
         * 游戏启动页面板
         */
        bootPanel: {
          prefabPath: `${(_crd && BundleConfigs === void 0 ? (_reportPossibleCrUseOfBundleConfigs({
            error: Error()
          }), BundleConfigs) : BundleConfigs).CommonBundle}/prefabs/boot/BootPanelPrefab`,
          layerZIndex: PanelLayerEnum.UILayer
        },

        /**
         * 游戏主面板
         */
        lobbyPanel: {
          prefabPath: `${(_crd && BundleConfigs === void 0 ? (_reportPossibleCrUseOfBundleConfigs({
            error: Error()
          }), BundleConfigs) : BundleConfigs).LobbyBundle}/prefabs/lobby/LobbyPanelPrefab`,
          layerZIndex: PanelLayerEnum.UILayer
        },
        // ///////////////////////////////////////////////////////
        // 弹窗层级

        /**
         * 通用加载页面
         */
        loadingPanel: {
          prefabPath: `${(_crd && BundleConfigs === void 0 ? (_reportPossibleCrUseOfBundleConfigs({
            error: Error()
          }), BundleConfigs) : BundleConfigs).CommonBundle}/prefabs/popwindow/LoadingPanelPrefab`,
          layerZIndex: PanelLayerEnum.PopLayer
        },

        /**
         * 通用Toast页面
         */
        toastPanel: {
          prefabPath: `${(_crd && BundleConfigs === void 0 ? (_reportPossibleCrUseOfBundleConfigs({
            error: Error()
          }), BundleConfigs) : BundleConfigs).CommonBundle}/prefabs/popwindow/ToastPanelPrefab`,
          layerZIndex: PanelLayerEnum.PopLayer
        },

        /**
         * 游戏设置面板
         */
        gameSettingPanel: {
          prefabPath: `${(_crd && BundleConfigs === void 0 ? (_reportPossibleCrUseOfBundleConfigs({
            error: Error()
          }), BundleConfigs) : BundleConfigs).LobbyBundle}/prefabs/gamesetting/GameSettingPanelPrefab`,
          layerZIndex: PanelLayerEnum.PopLayer
        }
      });

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=6483878d8bb779b226ba7f9500814029274f4a94.js.map