System.register(["__unresolved_0", "cc", "__unresolved_1"], function (_export, _context) {
  "use strict";

  var _reporterNs, _cclegacy, _decorator, Node, UIOpacity, Tween, tween, Vec3, v3, PanelComponent, _dec, _dec2, _dec3, _class, _class2, _descriptor, _descriptor2, _crd, ccclass, property, LoadingPanel;

  function _initializerDefineProperty(target, property, descriptor, context) { if (!descriptor) return; Object.defineProperty(target, property, { enumerable: descriptor.enumerable, configurable: descriptor.configurable, writable: descriptor.writable, value: descriptor.initializer ? descriptor.initializer.call(context) : void 0 }); }

  function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) { var desc = {}; Object.keys(descriptor).forEach(function (key) { desc[key] = descriptor[key]; }); desc.enumerable = !!desc.enumerable; desc.configurable = !!desc.configurable; if ('value' in desc || desc.initializer) { desc.writable = true; } desc = decorators.slice().reverse().reduce(function (desc, decorator) { return decorator(target, property, desc) || desc; }, desc); if (context && desc.initializer !== void 0) { desc.value = desc.initializer ? desc.initializer.call(context) : void 0; desc.initializer = undefined; } if (desc.initializer === void 0) { Object.defineProperty(target, property, desc); desc = null; } return desc; }

  function _initializerWarningHelper(descriptor, context) { throw new Error('Decorating class property failed. Please ensure that ' + 'proposal-class-properties is enabled and runs after the decorators transform.'); }

  function _reportPossibleCrUseOfPanelComponent(extras) {
    _reporterNs.report("PanelComponent", "../../../scripts/framework/lib/router/PanelComponent", _context.meta, extras);
  }

  function _reportPossibleCrUseOfPanelShowOption(extras) {
    _reporterNs.report("PanelShowOption", "../../../scripts/framework/lib/router/PanelComponent", _context.meta, extras);
  }

  function _reportPossibleCrUseOfPanelHideOption(extras) {
    _reporterNs.report("PanelHideOption", "../../../scripts/framework/lib/router/PanelComponent", _context.meta, extras);
  }

  return {
    setters: [function (_unresolved_) {
      _reporterNs = _unresolved_;
    }, function (_cc) {
      _cclegacy = _cc.cclegacy;
      _decorator = _cc._decorator;
      Node = _cc.Node;
      UIOpacity = _cc.UIOpacity;
      Tween = _cc.Tween;
      tween = _cc.tween;
      Vec3 = _cc.Vec3;
      v3 = _cc.v3;
    }, function (_unresolved_2) {
      PanelComponent = _unresolved_2.PanelComponent;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "76ffc0/+UBK+I+rrZBkcoxi", "LoadingPanelPrefab", undefined);

      ({
        ccclass,
        property
      } = _decorator);

      _export("default", LoadingPanel = (
      /**
       * 游戏通用 Loading 面板
       *
       * @author caizhitao
       * @created 2020-12-07 20:47:19
       */
      _dec = ccclass("LoadingPanel"), _dec2 = property(Node), _dec3 = property(Node), _dec(_class = (_class2 = class LoadingPanel extends (_crd && PanelComponent === void 0 ? (_reportPossibleCrUseOfPanelComponent({
        error: Error()
      }), PanelComponent) : PanelComponent) {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "bgNode", _descriptor, this);

          _initializerDefineProperty(this, "loadingSpriteNode", _descriptor2, this);

          this._showArgs = null;
        }

        onLoad() {
          this.bgNode.getComponent(UIOpacity).opacity = 0;
          this.loadingSpriteNode.getComponent(UIOpacity).opacity = 0;
        }

        show(option) {
          this._showArgs = option.data;

          if (this._showArgs == null || this._showArgs.playShowAnim == null || this._showArgs.playShowAnim) {
            // 默认播放loading动画
            this._playPanelShowAnim(() => {
              option.onShowed();
            });
          } else {
            option.onShowed();
          }
        }

        hide(option) {
          this._playPanelHideAnim(() => {
            this._showArgs = null;
            option.onHided();
          });
        }

        _playPanelShowAnim(onAnimCompleted) {
          Tween.stopAllByTarget(this.bgNode);
          tween(this.bgNode.getComponent(UIOpacity)).set({
            opacity: 0
          }).to(0.24, {
            opacity: 220
          }, {
            easing: "sineOut"
          }).call(() => {
            onAnimCompleted();
          }).start();
          Tween.stopAllByTarget(this.loadingSpriteNode);
          tween(this.loadingSpriteNode.getComponent(UIOpacity)).set({
            opacity: 0
          }).to(0.24, {
            opacity: 255
          }, {
            easing: "sineOut"
          }).start();
          tween(this.loadingSpriteNode).set({
            scale: new Vec3(2, 2, 1)
          }).to(0.24, {
            scale: new Vec3(1, 1, 1)
          }, {
            easing: "sineOut"
          }).start();
          tween(this.loadingSpriteNode).repeatForever(tween().by(0.7, {
            angle: -360
          })).start();
        }

        _playPanelHideAnim(onAnimCompleted) {
          Tween.stopAllByTarget(this.bgNode);
          tween(this.bgNode.getComponent(UIOpacity)).to(0.24, {
            opacity: 0
          }, {
            easing: "sineOut"
          }).call(() => {
            onAnimCompleted();
          }).start();
          Tween.stopAllByTarget(this.loadingSpriteNode);
          tween(this.loadingSpriteNode).to(0.24, {
            scale: v3()
          }, {
            easing: "sineOut"
          }).start();
          Tween.stopAllByTarget(this.loadingSpriteNode.getComponent(UIOpacity));
          tween(this.loadingSpriteNode.getComponent(UIOpacity)).to(0.24, {
            opacity: 0
          }, {
            easing: "sineOut"
          }).start();
        }

        onCancelLoadingBtnClick() {
          this._showArgs && this._showArgs.onCancelLoadingBtnClick && this._showArgs.onCancelLoadingBtnClick();
        }

      }, (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "bgNode", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "loadingSpriteNode", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=74c99aedaddcff981cdd2c7784e58a0d7b465912.js.map