System.register(["__unresolved_0", "cc", "__unresolved_1", "__unresolved_2", "__unresolved_3", "__unresolved_4", "__unresolved_5", "__unresolved_6", "__unresolved_7", "__unresolved_8", "__unresolved_9", "__unresolved_10", "__unresolved_11"], function (_export, _context) {
  "use strict";

  var _reporterNs, _cclegacy, LoadResConst, ZipFileMgr, TableFileConfigs, CFGTableFASkill, CFGTableFABuff, CFGTableFAHero, CFGTableFAHeroLevel, CFGTableFAHeroStar, CFGTableFAMap, CFGTableFATower, gg, ConfigTableMgr, _crd;

  function _reportPossibleCrUseOfLoadResConst(extras) {
    _reporterNs.report("LoadResConst", "../configs/LoadResConst", _context.meta, extras);
  }

  function _reportPossibleCrUseOfZipFileMgr(extras) {
    _reporterNs.report("ZipFileMgr", "../../../scripts/zipfile/ZipFileMgr", _context.meta, extras);
  }

  function _reportPossibleCrUseOfTableFileConfigs(extras) {
    _reporterNs.report("TableFileConfigs", "../configs/TableFileConfigs", _context.meta, extras);
  }

  function _reportPossibleCrUseOfCFGTableFASkill(extras) {
    _reporterNs.report("CFGTableFASkill", "./model/CFGTableFASkill", _context.meta, extras);
  }

  function _reportPossibleCrUseOfCFGTableFABuff(extras) {
    _reporterNs.report("CFGTableFABuff", "./model/CFGTableFABuff", _context.meta, extras);
  }

  function _reportPossibleCrUseOfCFGTableFAHero(extras) {
    _reporterNs.report("CFGTableFAHero", "./model/CFGTableFAHero", _context.meta, extras);
  }

  function _reportPossibleCrUseOfCFGTableFAHeroLevel(extras) {
    _reporterNs.report("CFGTableFAHeroLevel", "./model/CFGTableFAHeroLevel", _context.meta, extras);
  }

  function _reportPossibleCrUseOfCFGTableFAHeroStar(extras) {
    _reporterNs.report("CFGTableFAHeroStar", "./model/CFGTableFAHeroStar", _context.meta, extras);
  }

  function _reportPossibleCrUseOfCFGTableFAMap(extras) {
    _reporterNs.report("CFGTableFAMap", "./model/CFGTableFAMap", _context.meta, extras);
  }

  function _reportPossibleCrUseOfCFGTableFATower(extras) {
    _reporterNs.report("CFGTableFATower", "./model/CFGTableFATower", _context.meta, extras);
  }

  function _reportPossibleCrUseOfgg(extras) {
    _reporterNs.report("gg", "../../../scripts/framework/gg", _context.meta, extras);
  }

  function _reportPossibleCrUseOfCFGTableBase(extras) {
    _reporterNs.report("CFGTableBase", "./base/CFGTableBase", _context.meta, extras);
  }

  _export("default", void 0);

  return {
    setters: [function (_unresolved_) {
      _reporterNs = _unresolved_;
    }, function (_cc) {
      _cclegacy = _cc.cclegacy;
    }, function (_unresolved_2) {
      LoadResConst = _unresolved_2.default;
    }, function (_unresolved_3) {
      ZipFileMgr = _unresolved_3.default;
    }, function (_unresolved_4) {
      TableFileConfigs = _unresolved_4.TableFileConfigs;
    }, function (_unresolved_5) {
      CFGTableFASkill = _unresolved_5.CFGTableFASkill;
    }, function (_unresolved_6) {
      CFGTableFABuff = _unresolved_6.CFGTableFABuff;
    }, function (_unresolved_7) {
      CFGTableFAHero = _unresolved_7.CFGTableFAHero;
    }, function (_unresolved_8) {
      CFGTableFAHeroLevel = _unresolved_8.CFGTableFAHeroLevel;
    }, function (_unresolved_9) {
      CFGTableFAHeroStar = _unresolved_9.CFGTableFAHeroStar;
    }, function (_unresolved_10) {
      CFGTableFAMap = _unresolved_10.CFGTableFAMap;
    }, function (_unresolved_11) {
      CFGTableFATower = _unresolved_11.CFGTableFATower;
    }, function (_unresolved_12) {
      gg = _unresolved_12.gg;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "7d5d3BOG2VAZZ0lIkmC8zmz", "ConfigTableMgr", undefined);

      _export("default", ConfigTableMgr = class ConfigTableMgr {
        constructor() {
          this._allTableMap = void 0;
        }

        static get Inst() {
          if (ConfigTableMgr._inst == null) {
            ConfigTableMgr._inst = new ConfigTableMgr();
          }

          return ConfigTableMgr._inst;
        }

        async loadConfigTable() {
          let jsontable = await (_crd && ZipFileMgr === void 0 ? (_reportPossibleCrUseOfZipFileMgr({
            error: Error()
          }), ZipFileMgr) : ZipFileMgr).Inst.getJsonList((_crd && LoadResConst === void 0 ? (_reportPossibleCrUseOfLoadResConst({
            error: Error()
          }), LoadResConst) : LoadResConst).ConfigTable);
          let obj = {};

          for (const tablename in jsontable) {
            if (Object.prototype.hasOwnProperty.call(jsontable, tablename)) {
              obj[tablename] = {};
              let tablelist = jsontable[tablename];

              for (let i = 0; i < tablelist.length; i++) {
                let vo = this.resetData(tablename, tablelist[i]);
                obj[tablename][vo.id] = vo;
              }

              (_crd && gg === void 0 ? (_reportPossibleCrUseOfgg({
                error: Error()
              }), gg) : gg).logger.info(ConfigTableMgr.TAG, "loadConfigTable->表数据重置完成 tablename: ", tablename);
            }
          }

          this._allTableMap = obj;
          (_crd && gg === void 0 ? (_reportPossibleCrUseOfgg({
            error: Error()
          }), gg) : gg).logger.info(ConfigTableMgr.TAG, "loadConfigTable->配置表解析完成");
        }

        resetData(name, obj) {
          let itemcls = null;

          switch (name) {
            case (_crd && TableFileConfigs === void 0 ? (_reportPossibleCrUseOfTableFileConfigs({
              error: Error()
            }), TableFileConfigs) : TableFileConfigs).FightA_Skill:
              itemcls = _crd && CFGTableFASkill === void 0 ? (_reportPossibleCrUseOfCFGTableFASkill({
                error: Error()
              }), CFGTableFASkill) : CFGTableFASkill;
              break;

            case (_crd && TableFileConfigs === void 0 ? (_reportPossibleCrUseOfTableFileConfigs({
              error: Error()
            }), TableFileConfigs) : TableFileConfigs).FightA_Buff:
              itemcls = _crd && CFGTableFABuff === void 0 ? (_reportPossibleCrUseOfCFGTableFABuff({
                error: Error()
              }), CFGTableFABuff) : CFGTableFABuff;
              break;

            case (_crd && TableFileConfigs === void 0 ? (_reportPossibleCrUseOfTableFileConfigs({
              error: Error()
            }), TableFileConfigs) : TableFileConfigs).FightA_Hero:
              itemcls = _crd && CFGTableFAHero === void 0 ? (_reportPossibleCrUseOfCFGTableFAHero({
                error: Error()
              }), CFGTableFAHero) : CFGTableFAHero;
              break;

            case (_crd && TableFileConfigs === void 0 ? (_reportPossibleCrUseOfTableFileConfigs({
              error: Error()
            }), TableFileConfigs) : TableFileConfigs).FightA_HeroLevel:
              itemcls = _crd && CFGTableFAHeroLevel === void 0 ? (_reportPossibleCrUseOfCFGTableFAHeroLevel({
                error: Error()
              }), CFGTableFAHeroLevel) : CFGTableFAHeroLevel;
              break;

            case (_crd && TableFileConfigs === void 0 ? (_reportPossibleCrUseOfTableFileConfigs({
              error: Error()
            }), TableFileConfigs) : TableFileConfigs).FightA_HeroStar:
              itemcls = _crd && CFGTableFAHeroStar === void 0 ? (_reportPossibleCrUseOfCFGTableFAHeroStar({
                error: Error()
              }), CFGTableFAHeroStar) : CFGTableFAHeroStar;
              break;

            case (_crd && TableFileConfigs === void 0 ? (_reportPossibleCrUseOfTableFileConfigs({
              error: Error()
            }), TableFileConfigs) : TableFileConfigs).FightA_Map:
              itemcls = _crd && CFGTableFAMap === void 0 ? (_reportPossibleCrUseOfCFGTableFAMap({
                error: Error()
              }), CFGTableFAMap) : CFGTableFAMap;
              break;

            case (_crd && TableFileConfigs === void 0 ? (_reportPossibleCrUseOfTableFileConfigs({
              error: Error()
            }), TableFileConfigs) : TableFileConfigs).FightA_Tower:
              itemcls = _crd && CFGTableFATower === void 0 ? (_reportPossibleCrUseOfCFGTableFATower({
                error: Error()
              }), CFGTableFATower) : CFGTableFATower;
              break;

            default:
              (_crd && gg === void 0 ? (_reportPossibleCrUseOfgg({
                error: Error()
              }), gg) : gg).logger.warn(ConfigTableMgr.TAG, "resetData->没有对应解析类: name: ", name);
              break;
          }

          if (itemcls) {
            let ic = new itemcls();
            ic.creatbyObj(obj);
            return ic;
          }

          return obj;
        }
        /**
         * 根据表名和id获取数据元素
         * @param tablename @type TableFileConfigs
         * @param id 
         */


        getConfItemById(tablename, id) {
          if (!this._allTableMap[tablename]) {
            (_crd && gg === void 0 ? (_reportPossibleCrUseOfgg({
              error: Error()
            }), gg) : gg).logger.warn(ConfigTableMgr.TAG, "getConfTableById->没有对应数据: tablename: " + tablename);
            return null;
          }

          if (!this._allTableMap[tablename][id]) {
            (_crd && gg === void 0 ? (_reportPossibleCrUseOfgg({
              error: Error()
            }), gg) : gg).logger.warn(ConfigTableMgr.TAG, "getConfTableById->没有对应ID: tablename: " + tablename + " id: " + id);
            return null;
          }

          return this._allTableMap[tablename][id];
        }
        /**
         * 根据表名获取数据表
         * @param tablename @type TableFileConfigs
         */


        getTableByName(tablename) {
          if (!this._allTableMap[tablename]) {
            (_crd && gg === void 0 ? (_reportPossibleCrUseOfgg({
              error: Error()
            }), gg) : gg).logger.warn(ConfigTableMgr.TAG, "getTableByName->没有对应数据: tablename: " + tablename);
            return null;
          }

          return this._allTableMap[tablename];
        }

      });

      ConfigTableMgr.TAG = "ConfigTableMgr";
      ConfigTableMgr._inst = void 0;

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=7c9e1412aa15d5cb1643affa9956e0ae24d8a396.js.map