System.register(["__unresolved_0", "cc", "__unresolved_1"], function (_export, _context) {
  "use strict";

  var _reporterNs, _cclegacy, Asset, assetManager, gg, LoadMgr, _crd;

  function _reportPossibleCrUseOfILoadResInfo(extras) {
    _reporterNs.report("ILoadResInfo", "./interfaces/ILoadResInfo", _context.meta, extras);
  }

  function _reportPossibleCrUseOfgg(extras) {
    _reporterNs.report("gg", "../framework/gg", _context.meta, extras);
  }

  _export("default", void 0);

  return {
    setters: [function (_unresolved_) {
      _reporterNs = _unresolved_;
    }, function (_cc) {
      _cclegacy = _cc.cclegacy;
      Asset = _cc.Asset;
      assetManager = _cc.assetManager;
    }, function (_unresolved_2) {
      gg = _unresolved_2.gg;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "2c1cfbP5j1PAr2Z34yTp38a", "LoadMgr", undefined);

      _export("default", LoadMgr = class LoadMgr {
        static get Inst() {
          if (LoadMgr._inst == null) {
            LoadMgr._inst = new LoadMgr();
          }

          return LoadMgr._inst;
        }
        /**
         * 同步加载资源
         * @param resInfo 
         */


        async getAssetAsync(resInfo) {
          return new Promise((resolve, reject) => {
            let loadBundlePrefab = bundle => {
              bundle.load(resInfo.path, Asset, (error, resLoad) => {
                (_crd && gg === void 0 ? (_reportPossibleCrUseOfgg({
                  error: Error()
                }), gg) : gg).logger.log(LoadMgr.TAG + "::getAssetAsync-> ", resLoad);
                error ? resolve(null) : resolve(resLoad);
              });
            };

            let bundle = assetManager.getBundle(resInfo.bundle);

            if (bundle == null) {
              (_crd && gg === void 0 ? (_reportPossibleCrUseOfgg({
                error: Error()
              }), gg) : gg).logger.warn(LoadMgr.TAG + "::getAssetAsync-> " + resInfo.bundle + " auto load 加载开始");
              assetManager.loadBundle(resInfo.bundle, (error, bundle) => {
                (_crd && gg === void 0 ? (_reportPossibleCrUseOfgg({
                  error: Error()
                }), gg) : gg).logger.log(LoadMgr.TAG + "::getAssetAsync-> " + resInfo.bundle + " auto load 加载完成");
                loadBundlePrefab(bundle);
              });
            } else {
              loadBundlePrefab(bundle);
            }
          });
        }
        /**
         * 异步(回调方式)加载资源
         * @param resInfo 
         */


        getAsset(resInfo, callback) {
          let loadBundlePrefab = bundle => {
            bundle.load(resInfo.path, Asset, (error, resLoad) => {
              (_crd && gg === void 0 ? (_reportPossibleCrUseOfgg({
                error: Error()
              }), gg) : gg).logger.log(LoadMgr.TAG + "::getAsset-> error: ", error, " resLoad:", resLoad);
              error ? callback(null) : callback(resLoad);
            });
          };

          let bundle = assetManager.getBundle(resInfo.bundle);

          if (bundle == null) {
            (_crd && gg === void 0 ? (_reportPossibleCrUseOfgg({
              error: Error()
            }), gg) : gg).logger.warn(LoadMgr.TAG + "::getAsset-> " + resInfo.bundle + " auto load 加载开始");
            assetManager.loadBundle(resInfo.bundle, (error, bundle) => {
              (_crd && gg === void 0 ? (_reportPossibleCrUseOfgg({
                error: Error()
              }), gg) : gg).logger.log(LoadMgr.TAG + "::getAsset-> " + resInfo.bundle + " auto load 加载完成");
              loadBundlePrefab(bundle);
            });
          } else {
            loadBundlePrefab(bundle);
          }
        }

      });

      LoadMgr.TAG = "LoadMgr";
      LoadMgr._inst = void 0;

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=c97d7416baf127f203a6891ab674a7a5c2181d81.js.map