System.register(["cc"], function (_export, _context) {
  "use strict";

  var _cclegacy, assetManager, AssetLoader, _crd;

  _export("default", void 0);

  return {
    setters: [function (_cc) {
      _cclegacy = _cc.cclegacy;
      assetManager = _cc.assetManager;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "2d79fL3TuZCdYbkQPGtVJXh", "AssetLoader", undefined);

      /**
       * 提供 Promise 写法的 cc.assetManager 加载器，但是这种写法会缺失加载进度
       *
       * @author caizhitao
       * @created 2020-11-28 12:29:04
       */
      _export("default", AssetLoader = class AssetLoader {
        static loadBundle(bundleName) {
          return new Promise((resolve, reject) => {
            assetManager.loadBundle(bundleName, (error, bundle) => {
              error ? reject(error) : resolve(bundle);
            });
          });
        }

      });

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=8b812ca8a800b157c4788ac634314edb9e608c5c.js.map