System.register(["cc"], function (_export, _context) {
  "use strict";

  var _cclegacy, BundleLoader, _crd;

  _export("default", void 0);

  return {
    setters: [function (_cc) {
      _cclegacy = _cc.cclegacy;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "4c4a4bjWppAqp8Sk2iKxYIV", "BundleLoader", undefined);

      /**
       * 提供 Promise 写法的 Bundler 加载器，但是这种写法会缺失加载进度
       *
       * @author caizhitao
       * @created 2020-11-28 10:27:10
       */
      _export("default", BundleLoader = class BundleLoader {
        static load(bundle, path, type) {
          return new Promise((resolve, reject) => {
            bundle.load(path, type, (error, asset) => {
              error ? reject(error) : resolve(asset);
            });
          });
        }

        static loadDir(bundle, dirPath, type) {
          return new Promise((resolve, reject) => {
            bundle.loadDir(dirPath, type, (error, asset) => {
              error ? reject(error) : resolve(asset);
            });
          });
        }

        static loadScene(bundle, sceneName, options) {
          return new Promise((resolve, reject) => {
            bundle.loadScene(sceneName, options, (error, asset) => {
              error ? reject(error) : resolve(asset);
            });
          });
        }

      });

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=b3fa7b86bc7ef324bce76b984a17624c90d530de.js.map