System.register(["cc"], function (_export, _context) {
  "use strict";

  var _cclegacy, GameSettingModel, _crd;

  _export("default", void 0);

  return {
    setters: [function (_cc) {
      _cclegacy = _cc.cclegacy;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "bf5caIPFYxNhrmwtGjMNqzk", "GameSettingModel", undefined);

      /**
       * 游戏设置模块数据
       *
       * @author caizhitao
       * @created 2020-12-10 21:02:57
       */
      _export("default", GameSettingModel = class GameSettingModel {
        constructor() {
          this.musicVolume = 1;
          this.soundVolume = 1;
          this.enableVibrate = true;
        }

        fromJSON(json) {
          this.musicVolume = json.musicVolume;
          this.soundVolume = json.soundVolume;
          this.enableVibrate = json.enableVibrate;
          return this;
        }

        toJSON() {
          let json = {};
          json = Object.assign(json, this);
          return json;
        }

        toJsonString() {
          return JSON.stringify(this.toJSON());
        }

      });

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=313cf6b2f345af98bc48483c95b065d1c83104d8.js.map