System.register(["__unresolved_0", "cc"], function (_export, _context) {
  "use strict";

  var _reporterNs, _cclegacy, CCLogger, _crd;

  function _reportPossibleCrUseOfLoggerInterface(extras) {
    _reporterNs.report("LoggerInterface", "./LoggerInterface", _context.meta, extras);
  }

  function _reportPossibleCrUseOfLoggerOption(extras) {
    _reporterNs.report("LoggerOption", "./LoggerInterface", _context.meta, extras);
  }

  _export("default", void 0);

  return {
    setters: [function (_unresolved_) {
      _reporterNs = _unresolved_;
    }, function (_cc) {
      _cclegacy = _cc.cclegacy;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "730ebQ3s6NC55eToZRSHsm0", "CCLogger", undefined);

      /**
       * @author caizhitao
       * @created 2020-11-26 22:52:45
       */
      _export("default", CCLogger = class CCLogger {
        constructor() {
          this._option = null;
        }

        init(option) {
          this._option = option;
        }

        log(...args) {
          this._option && this._option.enableLog && console.log.apply(null, args);
        }

        debug(...args) {
          this._option && this._option.enableLog && console.debug.apply(null, args);
        }

        info(...args) {
          this._option && this._option.enableLog && console.info.apply(null, args);
        }

        warn(...args) {
          this._option && this._option.enableLog && console.warn.apply(null, args);
        }

        error(...args) {
          this._option && this._option.enableLog && console.error.apply(null, args);
        }

      });

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=8d3320bf9eb8d70a0ab6992e3567a21bee5b1e0a.js.map