System.register(["__unresolved_0", "cc", "__unresolved_1"], function (_export, _context) {
  "use strict";

  var _reporterNs, _cclegacy, SafeAreaAdapterComponent, _decorator, Component, Widget, UITransform, _dec, _dec2, _dec3, _dec4, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _crd, ccclass, property, SafeAreaWidgetAdapterComponent;

  function _initializerDefineProperty(target, property, descriptor, context) { if (!descriptor) return; Object.defineProperty(target, property, { enumerable: descriptor.enumerable, configurable: descriptor.configurable, writable: descriptor.writable, value: descriptor.initializer ? descriptor.initializer.call(context) : void 0 }); }

  function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) { var desc = {}; Object.keys(descriptor).forEach(function (key) { desc[key] = descriptor[key]; }); desc.enumerable = !!desc.enumerable; desc.configurable = !!desc.configurable; if ('value' in desc || desc.initializer) { desc.writable = true; } desc = decorators.slice().reverse().reduce(function (desc, decorator) { return decorator(target, property, desc) || desc; }, desc); if (context && desc.initializer !== void 0) { desc.value = desc.initializer ? desc.initializer.call(context) : void 0; desc.initializer = undefined; } if (desc.initializer === void 0) { Object.defineProperty(target, property, desc); desc = null; } return desc; }

  function _initializerWarningHelper(descriptor, context) { throw new Error('Decorating class property failed. Please ensure that ' + 'proposal-class-properties is enabled and runs after the decorators transform.'); }

  function _reportPossibleCrUseOfSafeAreaAdapterComponent(extras) {
    _reporterNs.report("SafeAreaAdapterComponent", "./SafeAreaAdapterComponent", _context.meta, extras);
  }

  return {
    setters: [function (_unresolved_) {
      _reporterNs = _unresolved_;
    }, function (_cc) {
      _cclegacy = _cc.cclegacy;
      _decorator = _cc._decorator;
      Component = _cc.Component;
      Widget = _cc.Widget;
      UITransform = _cc.UITransform;
    }, function (_unresolved_2) {
      SafeAreaAdapterComponent = _unresolved_2.default;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "59625om3shNXbWvSuYABXpb", "SafeAreaWidgetAdapterComponent", undefined);

      ({
        ccclass,
        property
      } = _decorator);
      /**
       * @author zhitaocai
       * @classdesc  安全区域适配Widget
       * @description
       *
       * 用法：
       *
       * 1. 将本组件挂载在节点上即可（注意：该节点上必须挂在 Widget 组件）
       *
       * 适配原理：
       *
       * 1. 根据安全区域范围，修改widget组件属性
       */

      _export("default", SafeAreaWidgetAdapterComponent = (_dec = property({
        tooltip: "是否包含安全区域和屏幕上边界之间的缝隙"
      }), _dec2 = property({
        tooltip: "是否包含安全区域和屏幕下边界之间的缝隙"
      }), _dec3 = property({
        tooltip: "是否包含安全区域和屏幕左边界之间的缝隙"
      }), _dec4 = property({
        tooltip: "是否包含安全区域和屏幕右边界之间的缝隙"
      }), ccclass(_class = (_class2 = class SafeAreaWidgetAdapterComponent extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "withInsertTop", _descriptor, this);

          _initializerDefineProperty(this, "withInsertBottom", _descriptor2, this);

          _initializerDefineProperty(this, "withInsertLeft", _descriptor3, this);

          _initializerDefineProperty(this, "withInsertRight", _descriptor4, this);
        }

        onLoad() {
          this._onResize();
        }

        onEnable() {
          let onResize = this._onResize.bind(this);

          window.addEventListener("resize", onResize);
          window.addEventListener("orientationchange", onResize);
        }

        onDisable() {
          let onResize = this._onResize.bind(this);

          window.removeEventListener("resize", onResize);
          window.removeEventListener("orientationchange", onResize);
        }

        _onResize() {
          let widget = this.getComponent(Widget);

          if (!widget || !widget.enabled) {
            return;
          } // 如果对齐上边界，并且包含安全区域到屏幕上边界的缝隙


          if (widget.isAlignTop && this.withInsertTop) {
            widget.isAbsoluteTop = true;
            widget.top = -(_crd && SafeAreaAdapterComponent === void 0 ? (_reportPossibleCrUseOfSafeAreaAdapterComponent({
              error: Error()
            }), SafeAreaAdapterComponent) : SafeAreaAdapterComponent).screenPxToDesignPx((_crd && SafeAreaAdapterComponent === void 0 ? (_reportPossibleCrUseOfSafeAreaAdapterComponent({
              error: Error()
            }), SafeAreaAdapterComponent) : SafeAreaAdapterComponent).safeArea.safeAreaMarginTop);
            this.node.getComponent(UITransform).height += Math.abs(widget.top);
          } // 如果对齐下边界，并且包含安全区域到屏幕下边界的缝隙


          if (widget.isAlignBottom && this.withInsertBottom) {
            widget.isAbsoluteBottom = true;
            widget.bottom = -(_crd && SafeAreaAdapterComponent === void 0 ? (_reportPossibleCrUseOfSafeAreaAdapterComponent({
              error: Error()
            }), SafeAreaAdapterComponent) : SafeAreaAdapterComponent).screenPxToDesignPx((_crd && SafeAreaAdapterComponent === void 0 ? (_reportPossibleCrUseOfSafeAreaAdapterComponent({
              error: Error()
            }), SafeAreaAdapterComponent) : SafeAreaAdapterComponent).safeArea.safeAreaMarginBottom);
            this.node.getComponent(UITransform).height += Math.abs(widget.bottom);
          } // 如果对齐左边界，并且包含安全区域到屏幕左边界的缝隙


          if (widget.isAlignLeft && this.withInsertLeft) {
            widget.isAbsoluteLeft = true;
            widget.left = -(_crd && SafeAreaAdapterComponent === void 0 ? (_reportPossibleCrUseOfSafeAreaAdapterComponent({
              error: Error()
            }), SafeAreaAdapterComponent) : SafeAreaAdapterComponent).screenPxToDesignPx((_crd && SafeAreaAdapterComponent === void 0 ? (_reportPossibleCrUseOfSafeAreaAdapterComponent({
              error: Error()
            }), SafeAreaAdapterComponent) : SafeAreaAdapterComponent).safeArea.safeAreaMarginLeft);
            this.node.getComponent(UITransform).width += Math.abs(widget.left);
          } // 如果对齐右边界，并且包含安全区域到屏幕右边界的缝隙


          if (widget.isAlignRight && this.withInsertRight) {
            widget.isAbsoluteRight = true;
            widget.right = -(_crd && SafeAreaAdapterComponent === void 0 ? (_reportPossibleCrUseOfSafeAreaAdapterComponent({
              error: Error()
            }), SafeAreaAdapterComponent) : SafeAreaAdapterComponent).screenPxToDesignPx((_crd && SafeAreaAdapterComponent === void 0 ? (_reportPossibleCrUseOfSafeAreaAdapterComponent({
              error: Error()
            }), SafeAreaAdapterComponent) : SafeAreaAdapterComponent).safeArea.safeAreaMarginRight);
            this.node.getComponent(UITransform).width += Math.abs(widget.right);
          }

          widget.updateAlignment();
        }

      }, (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "withInsertTop", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return false;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "withInsertBottom", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return false;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "withInsertLeft", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return false;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "withInsertRight", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return false;
        }
      })), _class2)) || _class));

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=e3908ce07041d907bdd7a9f0eca3623e7e14b82c.js.map